#ifndef _WIN32_WINNT            // Specifies that the minimum required platform is Windows Vista.
#define _WIN32_WINNT 0x0600     // Change this to the appropriate value to target other versions of Windows.
#endif

#include <windows.h>
#include <stdio.h>

static int a = 0;
const int b = 32456821;
const int m = 100000000; // the maximum +1

void init_random(int seed)
{
	a = seed;
}

// multiply elliminating overflow
int safe_multiply(int p, int q)
{
	const int m1 = 10000;
	int p1,p0,q1,q0;
	int ret;

	p1 = p/m1; p0 = p%m1;
	q1 = q/m1; q0 = q%m1;

	ret = (((p0*q1+p1*q0)%m1)*m1+p0*q0);

	return ret;
}

int random()
{
	a = (safe_multiply(a,b)+1) % m;
	return a;
}

int main(int argc, char** argv)
{
	int i;
	
	// use system time counter for initial seed so that two runs are almist impossible to be the same
	init_random(GetTickCount()%100000);
	// or use the same seed to generate the same sequence 
	//init_random(12345);

	// generate 20 random numbers in the range 0-99
	for (i=0; i<20; i++)
	{
		int val = random()%100;
		printf("%d -> %d\n", i, val);
	}
	return 0;
}
